/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package orggradle.experiments;

import java.io.File;
import java.io.IOException;
import java.io.Writer;
import java.io.FileWriter;

import org.gradle.testkit.runner.GradleRunner;
import org.gradle.testkit.runner.BuildResult;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;
import static org.junit.jupiter.api.Assertions.*;

/**
 * A simple functional test for the 'single.target.greeting' plugin.
 */
class SingleTargetJavaLibraryPluginFunctionalTest {
    @TempDir
    File projectDir;

    private File getBuildFile() {
        return new File(projectDir, "build.gradle");
    }

    private File getSettingsFile() {
        return new File(projectDir, "settings.gradle");
    }

    @Test void canRunTask() throws IOException {
        writeString(getSettingsFile(), "rootProject.name = 'single-target'");
        writeString(getBuildFile(), """
            plugins {
                id('orggradle.experiments.javalibrary')
            }
            repositories {
                mavenCentral()
            }
            
            
            
            
            javaLibrary {
                sources {
                    java {
                        srcDir "src/other/java"
                    }
                }
                dependencies {
                    api("com.google.guava:guava:28.0-jre")
                }

                debug = false    
            }
            """);

        // Run the build
        GradleRunner runner = GradleRunner.create();
        runner.forwardOutput();
        runner.withPluginClasspath();
        runner.withArguments("dependencies", "printModel");
        runner.withProjectDir(projectDir);
        BuildResult result = runner.build();
    }

    private void writeString(File file, String string) throws IOException {
        try (Writer writer = new FileWriter(file)) {
            writer.write(string);
        }
    }
}
